; Variables, constants, and macros GUI BGE v3.o9
; ,    GUI BGE v3.o9

CS      EQU #E3
SS      EQU #0E

; , , /,  (buffer, addr, sector/track, page)
; B = -  (number of sectors)

        MACRO EXLOAD p1,p2,p3,p4
        LD A,p4
        LD HL,p1
        LD DE,p2
        LD IX,(p3)
        LD C,#05
    ;    LD A,p4     ;        a   /DA
        EX AF,AF'
        LD A,SL_BANK
        CALL GUI
        ENDM

; , ,   ,  (buffer, addr, byte length, page)
; B = -  (number of sectors)
;   (save file)

        MACRO EXSAVEF p1,p2,p3,p4
        LD A,p4
        LD HL,p1
        LD DE,p2
        LD IX,p3
        LD C,11
     ;   LD A,p4   ;        a   /DA
        EX AF,AF'
        LD A,SL_BANK
        CALL GUI
        ENDM

        MACRO RestSpp
        DI
        LD SP,(Spp)
        EI
        ENDM

        MACRO HLFHL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        ENDM

        MACRO DEFHL ;macro for LD DE,(HL)
        LD E,(HL)
        INC HL
        LD D,(HL)
        ENDM

        MACRO DEFHL1 ;LD DE,(HL):INC HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        ENDM

        MACRO Amul8
        ADD A,A
        ADD A,A
        ADD A,A
        ENDM

        MACRO CPHL0
        LD A,H
        OR L
        ENDM

        MACRO DHL_
        INC H
        LD A,H
        AND #07
        JR NZ,$+12
        LD A,L
        SUB #E0
        LD L,A
        JR NC,$+6
        LD A,H
        SUB #08
        LD H,A
        ENDM

        MACRO HL0
        AND A
        SBC HL,HL
        ENDM

; Constants of GUI

RadioOn  EQU 1              ; - . (radio-button on)
RadioOff EQU 2              ; - . (radio-button off)
SwchOn   EQU 3              ;  . (flag on)
SwchOff  EQU 4              ;  . (flag off)
Nil      EQU 0              ;   () (no value)
NEWCAT   EQU #FFFF-#0800    ;    (sorted file list)
CAT      EQU NEWCAT-#0900   ;   (full directory)

; Main variable of GUI

GuiVars           ;             /DA

Numb    DEFB 0    ;    (number of selected highlighting)
But     DEFB 0    ;    (number of selected button)
DIRECT  DEFB 0
MDIRECT DEFB 0
ARW_X   DEFB 127  ;. (starting cordinates...)
ARW_Y   DEFB 95   ;  . . (...of the cursor)
ARW_XC  DEFB 0    ;    (in characters here)
ARW_YC  DEFB 0    ;
ARWXMN  DEFB 0    ;x min
ARWXMX  DEFB 255  ;x max
ARWYMN  DEFB 0    ;y min
ARWYMX  DEFB 191  ;y max
XPLACE  DEFW 22528
ARW_ADR DEFW ARWSPR
STEP    DEFB 6
LEVEL   DEFB 10
SPEED   DEFB 1
ARWSPR  DB 63,0,15,64,131,48,129,60
        DB 193,24,193,20,224,2,252,0
        DB 255,0,255,0
KJOY    DB 0 ; KEMPSTON JOY

MvarNUM   EQU ARWSPR-GuiVars   ;       - /DA

; Main variable of ListBox

SpAdr    DW 0    ;    (start addr of the list)
SpAdrT   DW 0    ;     (start addr of visible list)
SpLen    DW 0    ;     (length of full title of the list)
SpLenW   DW 0    ;     (length of title of visual list)
SpLenD   DW 0    ;     .  (length of title with extra text)
SpDop    DW 0    ;     (addr of procedure "add to list")
SpBar    DB 0    ;   (length of highlighting)
SpFiler  DB 0    ;  ? (is this a file selector?)
SpXY     DW 0    ; X,Y    (X,Y of the list in the window)
SelSp    DB 0    ;     (item number in the list)
SpDop2   DW 0    ;      (add text after the list)
TAB_SORT DW 0    ;   (sorting table)


; Main Constants of TRDOS

LAST_KEY   EQU 23560
FILE_PARAM EQU #5CDD
FILE_NAME  EQU #5CDD
FILE_TYPE  EQU #5CE5
START_ADR  EQU #5CE6
BYTES_LEN  EQU #5CE8
SEC_LEN    EQU #5CEA
START_SEC  EQU #5CEB
START_TRK  EQU #5CEC
TEK_SEC    EQU #5CF4
TEK_TRK    EQU #5CF5

; Main variable of FDOS

Spp       DW 0         ;  ,     (stack address for error handling)
MODE      DB #00       ;    (turbo driver flag)
RECAT     DB 0         ;      (re-read directory after save)
RAMDR     DB 2         ;   #3D13 (drive with #3D13)
OVERF     DB 0
ResAdr    DW 0         ;   (resident addr)
END_DISK  DW 0         ;  /  (last track/sector of the disk)

; Disk constants

All_File EQU 228
Free_Sec EQU 229
End_Disk EQU 225

; ReadKey variable

KEYS
KEY1    DB 0
KEY2    DB 0

; Mouse variable
FIRE    DB 0
CANCEL  DB 0

SPACE   DEFS 50;51
CROSSON db 0 ;#ff ;    /DA

BRK     DB 0          ; %001 -  (fire)
                      ; %010 -  (cancel)
                      ; %100 -  (mouse)
                      ; %000 - halt

FREE_SEC        DW 0  ;     (number of free sectors on the disk)
ALL_FILE        DW 0  ;     (number of files on the disk)

;      LOAD_CAT, ,
;   ,    GUI (,
;  ,     ...)
;(the following variables are set after calling LOAD_CAT, it is called
;by GUI disk functions (file selector, save file, load file with reading the header...))
; END_DISK       /  (last track/sector of the disk)
; FREE_SEC          (number of free sectors on the disk)
; ALL_FILE          (number of files on the disk)

MICE            DB 0;#ff      ;  (mouse flag)
MB              DB 0      ;  (reverse buttons flag)

ARW_SDISP       DB 0,0   ;        x,y   
ARW_XDISP       DB 0     ;        X
ARW_YDISP       DB 0     ;        Y

PixelMSK        DB 0     ;   : 0-15  , 16-32 -  
Magnify_x8      DB 0 ; #FF  ; /DA   0 -  x4 , !=0 - x8
Sieve           DB 0 ; #FF  -     0 - , #FF -  (  ) /DA



  ;  Numbers of system buttons sprites of BGE \     BGE
  ;  0-47 ; If add bit 7 (+128) then used last half sprite addr. \    7 (+128),      .
  ;  /DA

DISKS       EQU 1
PGN1S       EQU 2
PGN2S       EQU 2+128
CHRS        EQU 3
WIN8S       EQU 4
WIN1S       EQU 5
RGBS        EQU 6
MGFS        EQU 7
CNKS        EQU 8
NALS        EQU 9
EK2S        EQU 10
FILLS       EQU 11
PRIMS       EQU 12
BOXS        EQU 13
OTHERS      EQU 14
UNDOS       EQU 15
EXITS       EQU 16
OFFS        EQU 17
ONS         EQU 18
DTRS        EQU 19
PLOTS       EQU 20
LINES       EQU 21
LINES2      EQU 22
TRS         EQU 23
SQS         EQU 24
CIRCS       EQU 25
ELPS        EQU 26
RAYS        EQU 27
XORS        EQU 28
ANDS        EQU 29
ORS         EQU 30
NOPS        EQU 31
ERASES      EQU 32
SETKAS      EQU 33
RAMKAS      EQU 34
FILLS2      EQU 35
AMASKS      EQU 36
NORGBS      EQU 37
WASHS1      EQU 38
BRUSHS      EQU 39
ZOOM8       EQU 40
ZOOM4       EQU 41
LASTONS     EQU 42
FILLSQS     EQU 43
BOLDDOTS    EQU 44
DTPMASKS    EQU 45
SPRAYS      EQU 46
SPRITESS    EQU 47
;           EQU 48  ; reserves

 ;   display "mice:", MICE
    display "End GuiVar:", $
